/******************************************************************************
File:	 	equivSearch.c
Description: 	Handles the process of searching, both interactively and automaticaly.

Comments:    	TODO:
			
		
	
Created:	Z.Bukovac Apr 2012
*******************************************************************************/

#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include "graph.h"
#include "cert.h"

char outFileName[] = "certificates";
char *outFileMode = "a+";
int certCount = 0;

int defaultMaxDepth = 8;  //THIS SETS THE MAXIMUM DEPTH TO WHICH THE EXHAUSTIVE SEARCH WILL LOOK
int maxDepth;
int minDepth;

graph targetGraph = NULL;


graph * currentCEGraphs;
int * currentCEList;
cert currentShortest;

int totalOps;




cert equivSearch(graph g1, graph g2);
void equivSearchTest();
void printCertificateData(cert inpCert);

void autoSearch();
void exhaustiveSearch();
void expand(cert searchCert, int currentDepth, int maxDepth, FILE *outFile);
void shortestForPairSearch(graph inpGraph1, graph inpGraph2, int initialMaxDepth, FILE *outFile);
void expandShortestForPair(cert searchCert, int currentDepth, FILE *outFile);
void randomOp(cert searchCert);
void weightedOp(cert searchCert);

/******************************************************************************
*********************************BEGIN FUNCTIONS*******************************
*******************************************************************************/


/*
cert equivSearch(graph g1, graph g2)
{
	cert searchCert = newCert(g1);
	//If G1 is clique separable, return a cert of the form H1H2/Kr
	int *clique;
	clique = malloc(getSize(g1) * sizeof( int));
	int cliqueSep = isCliqueSeparable(g1, clique);
	if(cliqueSep)
	{
		//addline(cert,)
	}
	

}*/
void equivSearchTest()
{
	//Try clique separation
	
	//TEST
	graph g1 = createGraph(6);
	char ans;
	int *clique;
	clique = malloc(getSize(g1) * sizeof( int));
	int cliqueSep = isCliqueSeparable(g1, clique);
	printf("It is clique separable?: %d\n", cliqueSep);
	if(1)
	{	
		int i;
		for(i = 0; i<getSize(g1); i++)
		{
			printf("%d\n", clique[i]);
		}

	
	}
	printGraph(g1);
}

void printCertificateData(cert inpCert)
{
	printCert(inpCert);
}

void autoSearch()
{
	srand(time(NULL));
	/*graph graph = initGraph(9);
	addEdge(graph,0,1);
	addEdge(graph,1,2);
	addEdge(graph,2,3);
	addEdge(graph,3,4);
	addEdge(graph,4,5);
	addEdge(graph,5,6);
	addEdge(graph,6,7);
	addEdge(graph,7,8);*/
	
	//Kerri's graph
	graph graph = initGraph(12);
	addEdge(graph,0,1);
	addEdge(graph,0,2);
	addEdge(graph,0,8);
	addEdge(graph,1,2);
	addEdge(graph,1,3);
	addEdge(graph,2,4);
	addEdge(graph,3,4);
	addEdge(graph,3,5);
	addEdge(graph,4,6);
	addEdge(graph,5,6);
	addEdge(graph,5,7);
	addEdge(graph,6,7);
	addEdge(graph,7,11);
	addEdge(graph,8,9);
	addEdge(graph,8,10);
	addEdge(graph,9,10);
	addEdge(graph,9,11);
	addEdge(graph,10,11);
	
	/*graph graph = initGraph(5);
	addEdge(graph,0,1);
	addEdge(graph,1,2);
	addEdge(graph,2,3);
	addEdge(graph,3,4);*/
	
	cert searchCert = newCert(graph);
	
	printCert(searchCert);
	printCertGraphs(searchCert);
	int count = 0;
	
	while( count < 10 && (getLength(searchCert) == 0 || getCurrentLineLength(searchCert) != 1)  )
	{
		if(getCurrentLineLength(searchCert) < getInitialGraphOrder(searchCert) && 
		   getLength(searchCert) < getInitialGraphOrder(searchCert))
		{
			printf("\nRANDOM\n");
			randomOp(searchCert);

		}
		else
		{
			printf("\nWEIGHTED\n");
			weightedOp(searchCert);

		}
		printCert(searchCert);
		printCertGraphs(searchCert);
		count++;
	}
}

void exhaustiveSearch()
{
	/*graph graph = initGraph(9);
	addEdge(graph,0,1);
	addEdge(graph,1,2);
	addEdge(graph,2,3);
	addEdge(graph,3,4);
	addEdge(graph,4,5);
	addEdge(graph,5,6);
	addEdge(graph,6,7);
	addEdge(graph,7,8);*/
	int maxDepth = 4;
	int currentDepth = 0;
	
	//Kerri's graph
	graph graph = initGraph(12);
	addEdge(graph,0,1);
	addEdge(graph,0,2);
	addEdge(graph,0,8);
	addEdge(graph,1,2);
	addEdge(graph,1,3);
	addEdge(graph,2,4);
	addEdge(graph,3,4);
	addEdge(graph,3,5);
	addEdge(graph,4,6);
	addEdge(graph,5,6);
	addEdge(graph,5,7);
	addEdge(graph,6,7);
	addEdge(graph,7,11);
	addEdge(graph,8,9);
	addEdge(graph,8,10);
	addEdge(graph,9,10);
	addEdge(graph,9,11);
	addEdge(graph,10,11);
	
	
	
	cert searchCert = newCert(graph);
	
	FILE *outFile = fopen(outFileName, outFileMode);
	
	expand(searchCert, currentDepth, maxDepth, outFile);
	
	fclose(outFile);
	
	printf("\nFound %d certificates of equivalence!", certCount);
	
	freeCert(searchCert);
	freeGraph(graph);
	certCount = 0;
}

void expand(cert searchCert, int currentDepth, int maxDepth, FILE *outFile)
{
	operationList list = getAllOperations(searchCert);
	operation currentOp;
	int numOfOps = getListLength(list);
	int i = 0;
	
	//printf("\nCurrentDepth = %d NumOps = %d\n",currentDepth, numOfOps);
	//printOperationList(list);
	//printf("\nCurrentDepth = %d Max = %d NumOps = %d\n",currentDepth,maxDepth, numOfOps);
	//printf("\n******************************************\n");
	//For each of the possible operations
	for(i = 0; i < numOfOps; i++)
	{
		//For each op..
		//Perform it,
		//Check to see if we're at a single graph or have reached maxDepth
		//If so, print the current certificate and return
		//If not,recurse onto the new line...

		//currentOp = getNextOp(list);
		line line = getCurrentLine(searchCert);
		performOp(getOpFromList(list, i));
		//printCert(searchCert);
		//printCertGraphs(searchCert);
		currentDepth++;

		//If the current line only has a single graph...
		if(getCurrentLineLength(searchCert) == 1 && !endGraphIsInitialGraph(searchCert) )
		{
			printf("\nFound a certificate of eqivalence, length %d!",getLength(searchCert));
			//printCert(searchCert);
			//printCertGraphs(searchCert);
			certCount++;
			//printf("\n");
			
			fprintf(outFile,"\n******************************************\n");
			printCertToFile(searchCert, outFile);
			printCertGraphsToFile(searchCert, outFile);
			removeLastLine(searchCert);
			currentDepth--;	
		}
		else if(currentDepth >= maxDepth || getCurrentLineLength(searchCert)-1 > ((maxDepth-currentDepth) * 2) || (getCurrentLineLength(searchCert) == 1 && (maxDepth-currentDepth) < 2))
		{
			//printf("\nNo valid length <= %d certificates beyond this point...pruning...\n",maxDepth);
			//printCert(searchCert);
			removeLastLine(searchCert);
			currentDepth--;
		}
		else
		{
			//Then call this function on the new tail of the certificate
			//printf("\nRecursing onto next line...\n");
			expand(searchCert, currentDepth, maxDepth, outFile);
			removeLastLine(searchCert);
			currentDepth--;
		}

	}
	freeList(list);
	
}


/******************************************************************************
Function:	shortestForPairSearch()
Description:	Searches for the shortest certificate for the given graphs of size <= maxDepth
Inputs:		TODO: Will need to take the two graphs as input
Return Value:	None
Side Effects:	Writes to the file named "certificates"
Notes:		TODO: Add the graph inputs, maybe change the name?
Created:	Z.Bukovac September 2012
******************************************************************************/
void shortestForPairSearch(graph inpGraph1, graph inpGraph2, int finalMaxDepth, FILE *outFile)
{
	totalOps = 0;
	int currentDepth = 0;
	int initialMaxDepth = 2;
	maxDepth = initialMaxDepth;
	minDepth = 2;
	
	cert searchCert = newCert(inpGraph1);
	targetGraph = inpGraph2;
	
	fprintf(outFile,"\n------------------------------------------");
	//fprintf(outFile,"\n\n******************************************");
	//fprintf(outFile,"\n******************************************");
	fprintf(outFile,"\nGRAPH PAIR: %d & %d\t",getCannonID(inpGraph1),getCannonID(inpGraph2));
	//fprintf(outFile,"\nGraph ID:%d",getCannonID(inpGraph1));
	//printGraphToFile(inpGraph1,outFile);
	//fprintf(outFile,"\nGRAPH PAIR:");
	//fprintf(outFile,"\nGraph ID:%d",getCannonID(inpGraph2));
	//printGraphToFile(inpGraph2,outFile);
	//fprintf(outFile,"\n------------------------------------------");
	//fprintf(outFile,"\nCERTIFICATES:");

	printf("Order: %d\n",getSize(inpGraph1));
	printf("Start graph ID:  %d\n", getCannonID(inpGraph1));
	printf("Target graph ID: %d\n", getCannonID(inpGraph2));
	
	
	while(certCount == 0 && maxDepth <= finalMaxDepth)
	{
		printf("\nStarting search from depth %d...\n",maxDepth);
		expandShortestForPair(searchCert, currentDepth, outFile);
		initialMaxDepth += 2;
		maxDepth = initialMaxDepth;
		minDepth += 2;
	}
	//fprintf(outFile,"Found %d certificates of equivalence!\n", certCount);
	
	printf("\nFound %d certificates of equivalence!\n", certCount);

	freeCert(searchCert);
	certCount = 0;
}

void expandShortestForPair(cert searchCert, int currentDepth, FILE *outFile)
{
	operationList list = NULL;
	operation currentOp;
	

	//Only retrieve the operations that shrink line length if we are about to create a line at the max depth
	if(currentDepth < maxDepth)
	{
		list = getAllOperations(searchCert);
	}
	else
	{
		list = getAllCompressingOperations(searchCert);

	}
	
	int numOfOps = getListLength(list);
	int i = 0, t = 0;
	totalOps +=  numOfOps;
	
	
	//printf("\nCurrentDepth = %d NumOps = %d\n",currentDepth, numOfOps);
	//printOperationList(list);
	//printf("\nCurrentDepth = %d Max = %d NumOps = %d\n",currentDepth,maxDepth, numOfOps);
	//printf("\n*******************!!***********************\n");
	//For each of the possible operations
	for(i = 0; i < numOfOps; i++)
	{

		//For each op..
		//Perform it,
		//Check the resulting line to see if we're at a single graph, and if it's the target, print the certificate, break from the operation list loop
		//If not, and we've reached maxDepth, or some other condition that makes a certificate imposible to find from this line, return
		//If none of the above, recurse onto the new line...

		//if(currentDepth==0) printf("Depth %d",currentDepth+1);
		/*printf("Depth %d",currentDepth+1);
		for(t = 0; t < currentDepth+1; t++)
		{
			printf("\t");
		}***/
		
		//currentOp = getNextOp(list);
		
		
		line line = getCurrentLine(searchCert);
		performOp( getOpFromList(list, i));
		
		float percentComplete;
		if(currentDepth == 0)
		{
				percentComplete =  ((float)(i+1)) / ((float)numOfOps) * (float)100;
				printf("\n%d%% COMPLETE",(int)(percentComplete));
		}
		currentDepth++;

		//If the current line only has a single graph...
		if(getCurrentLineLength(searchCert) == 1 && isLastGraph(searchCert, targetGraph))
		{
			printf("\t**Found a certificate of equivalence, length %d!**",getLength(searchCert));

			certCount++;
			//printf("\n");
			//printCert(searchCert);
			//printCertGraphs(searchCert);
			//freeCert(currentShortest);
			//currentShortest = copyCert(searchCert);
			//printCert(currentShortest);
			//printf("%s",printCertToString(searchCert));
			//fprintf(outFile,"\n------------------------------------------\n");
			//fprintf(outFile,"\nCURRENTDEPTH: %d  MAXDEPTH: %d\n", currentDepth, maxDepth);
			printCertToFile(searchCert, outFile);
			//fprintf(outFile,"\n");
			
			removeLastLine(searchCert);
			currentDepth--;
			maxDepth = currentDepth-1;		//Reduce maxDepth so we never look this deep again
			if(minDepth == maxDepth)
			{
				//We've already searched for all certs shorter than this, so free and return;
				freeList(list);
				return;
			}
			break;		//Don't bother searching the remainder of the current operation list, since we've already found a cert of this length
		}
		else if(    currentDepth >= maxDepth 							//If we are at maximum depth,
			||  getCurrentLineLength(searchCert)-1  >  ((maxDepth-currentDepth) * 2) 	//Or have have no room to compress to one graph in the remaining depth,
			|| (getCurrentLineLength(searchCert) == 1 && (maxDepth-currentDepth) < 2))	//Or there is no room remaining to expand and then compress to one graph,
		{
			//We don't want to go past this point
			removeLastLine(searchCert);
			currentDepth--;
		}
		else
		{
			//Call this function on the new tail of the certificate
			expandShortestForPair(searchCert, currentDepth, outFile);
			removeLastLine(searchCert);
			currentDepth--;
		}
	}
	freeList(list);
}


void randomOp(cert searchCert)
{
	
	operationList list;
	enum operationType optype;
	int opSelection;
	
	list = getAllOperations(searchCert);
	
	opSelection = rand() % getListLength(list);
	
	performOp(getOpFromList(list,opSelection));
	
}

void weightedOp(cert searchCert)
{
	
	operationList list;
	enum operationType optype;
	int opSelection;
	
	//Cancellation ops are first priority...
	list = getOperationList(searchCert,CANCEL);
	printf("\nCANCEL LIST IS EMPTY: %d\n",listIsEmpty(list));
	if(!listIsEmpty(list))
	{
		opSelection = rand() % getListLength(list);
		performOp(getOpFromList(list,opSelection));
		return;
	}
	
	//Then reversals...
	list = getOperationList(searchCert,INVDELCONT1),
	appendList(list, getOperationList(searchCert,INVDELCONT2));
	appendList(list, getOperationList(searchCert,INVADDIDENT));
	
	printf("\nREVERSE LIST IS EMPTY: %d\n",listIsEmpty(list));
	if(!listIsEmpty(list))
	{
		opSelection = rand() % getListLength(list);
		performOp(getOpFromList(list,opSelection));
		return;
	}
	
	//And finally expansions...
	list = getOperationList(searchCert,DELCONT);
	appendList(list, getOperationList(searchCert,ADDIDENT));
	
	if(!listIsEmpty(list))
	{
		opSelection = rand() % getListLength(list);
		performOp(getOpFromList(list,opSelection));
		return;
	}
}

void manualTest()
{
	int depth = 8;
	
	graph graph, target;
	
	//Kerri's graph
	graph = initGraph(12);

	addEdge(graph,0,1);
	addEdge(graph,0,2);
	addEdge(graph,0,8);
	addEdge(graph,1,2);
	addEdge(graph,1,3);
	addEdge(graph,2,4);
	addEdge(graph,3,4);
	addEdge(graph,3,5);
	addEdge(graph,4,6);
	addEdge(graph,5,6);
	addEdge(graph,5,7);
	addEdge(graph,6,7);
	addEdge(graph,7,11);
	addEdge(graph,8,9);
	addEdge(graph,8,10);
	addEdge(graph,9,10);
	addEdge(graph,9,11);
	addEdge(graph,10,11);
	
	//And its match
	target = initGraph(12);
	addEdge(target,0,1);
	addEdge(target,0,2);
	addEdge(target,0,6);
	addEdge(target,1,2);
	addEdge(target,1,3);
	addEdge(target,2,4);
	addEdge(target,3,4);
	addEdge(target,3,5);
	addEdge(target,4,5);
	addEdge(target,5,11);
	addEdge(target,6,7);
	addEdge(target,6,8);
	addEdge(target,7,8);
	addEdge(target,7,9);
	addEdge(target,8,10);
	addEdge(target,9,10);
	addEdge(target,9,11);
	addEdge(target,10,11);
	
	FILE *outFile = NULL;
	outFile = fopen(outFileName, outFileMode);
	if(outFile == NULL)
	{
		printf("Cannot open file \"%s\"",outFileName);
		return;
	}
	shortestForPairSearch(graph,target,depth,outFile);
	fclose(outFile);
}


void startSingleTest()
{
	singleTest(8,7,8,242); //depth, order, id1, id2
	printf("\n total ops: %d\n",totalOps);
	exit(0);
}

void singleTest(int depth, int graphOrder, int cannonID1, int cannonID2)
{	
	graph graph, target;
	int indices[2];
	
	indices[0] = cannonID1;
	indices[1] = cannonID2;
	
	readGraphsFromFile(indices,2,graphOrder);
	
	FILE *outFile = NULL;
	outFile = fopen(outFileName, outFileMode);
	if(outFile == NULL)
	{
		printf("Cannot open file \"%s\"",outFileName);
		return;
	}
	shortestForPairSearch(currentCEGraphs[1],currentCEGraphs[0],depth,outFile);
	fclose(outFile);
	freeCEData(2);
}

//Notes: This functions expects the graphIndices to be in ascending numerical order.
void readGraphsFromFile(int *graphIndices, int numOfIndices, int graphOrder)
{
	int i = 0, j = 0, k = 0;
	
	for(i = 0; i < numOfIndices; i++)
	{
		printf("%d ",graphIndices[i]);
	}
	printf("\n");
	
	//Setup some space for the array of graphs about to be created;
	currentCEGraphs = malloc(numOfIndices * sizeof(graph));
	graph currentGraph;
	
	//Open the relevant file
	char inFileName[20];
	sprintf(inFileName, "graphs/graphs%d",graphOrder); 
	FILE *inFile = fopen(inFileName, "r");
	if(inFile==NULL) {printf("Cannot open file \"%s\"",inFileName); return;}
	
	int offset = 2;		//Skip over the empty line and the description line for each graph in the file.
	int currentIndex = 0, adjMtrxStart = 0, lineCount = 0;
	char currentLine[100];
	
	for(i = 0; i < numOfIndices; i++)
	{
		currentGraph = initGraph(graphOrder);
		setCannonID(currentGraph,graphIndices[i]);
		currentCEGraphs[i] = currentGraph;
		currentIndex = graphIndices[i];
		adjMtrxStart = ((graphOrder + offset) * (currentIndex - 1)) + offset;
		printf("\n%d %d\n",i,adjMtrxStart);
		
		while(lineCount != adjMtrxStart)
		{
			//printf(" %d :",lineCount);
			fgets(currentLine,100,inFile);
			//printf("\*%s",currentLine);
			lineCount++;
		}
		
		for(j = 0; j < graphOrder; j++)
		{
			//printf("\n %d :",lineCount);
			fgets(currentLine,100,inFile);
			lineCount++;
			//printf("%s",currentLine);
			
			for(k = 0; k < j; k++)
			{
				if(currentLine[k]=='1')
				{
					addEdge(currentGraph,j,k);
				}
				//printf("%d%d[%c]",j,k,currentLine[k]);
			}
			
		}
		printf("\nGraph %d read sucessfully!", graphIndices[i]);
		printGraph(currentCEGraphs[i]);
	}
	fclose(inFile);
}


void batchSearch()
{
	int i = 0;
	int startOrder = 4;		//Will start searching for certificates for graphs of this order,
	int endOrder = 7;		//And will continue to search until this order is searched too.
	for(i = startOrder; i <= endOrder ; i++)
	{
		runCEBatchSearch(i);
	}
}

void runCEBatchSearch(int graphOrder)
{
	char inFileName[50];
	char outFileName[50];
	
	strcpy(inFileName,"");
	strcpy(outFileName,"");

	FILE *inFile = NULL;
	FILE *outFile = NULL;

	char * currentString[100];
	int currentInt = 0;
	int i = 0, j = 0;
	int graphIndices[100];
	int matches = 0, count = 0;

	//Construct the filenames for input and output.
	sprintf(inFileName, "graphs/%d_polys", graphOrder); 
	sprintf(outFileName, "graphs/order_%d_certificates", graphOrder);

	printf("infile: %s\n",inFileName);
	printf("outfile: %s\n",outFileName);
	
	//Open the input file.
	inFile = fopen(inFileName, "r");
	if(inFile == NULL) {
		printf("Cannot open file \"%s\"",inFileName);
		return;
	}

	//Open the output file.
	outFile = fopen(outFileName, outFileMode);
	if(outFile == NULL) {
		printf("Cannot open file \"%s\"",outFileName);
		return;
	}
	
	while(fscanf(inFile,"%*s : ") != -1)
	{
		while((matches = fscanf(inFile, "%d", &currentInt)) == 1)
		{
			for(i = count; /*empty*/; i--) {
				if (i == 0 || graphIndices[i-1] < currentInt) {
					graphIndices[i] = currentInt;
					break;
				} else {
					graphIndices[i] = graphIndices[i-1];
				}
			} 

			printf("\*%d at %d\n", graphIndices[i], i);
			count++;
		}
		
		
		printf("\n");
		
		printf("Count:%d\n",count);
		
		//Get the graphs requested from file;
		readGraphsFromFile(graphIndices, count, graphOrder);
		
		//Run the search for each pair of graphs in list we just retrieved
		for(i = 0; i < count; i++)
		{
			for(j = 0; j < i; j++)
			{
				shortestForPairSearch(currentCEGraphs[i], currentCEGraphs[j], defaultMaxDepth, outFile);
			}
		}
		freeCEData(count);
		count = 0;
	}
	
	//Close the input and output files.
	fclose(outFile);
	fclose(inFile);
}

void freeCEData(int count)
{
	int i = 0;
	for(i = 0; i < count; i++)
	{
		//printf("Ref count for %d: %d\n", i, getReferences(currentCEGraphs[i]));
		freeGraph(currentCEGraphs[i]);
	}
	free(currentCEList);
	free(currentCEGraphs);
}

/**********************************************************************************/
/**********************************EXTRAS******************************************/
/**********************************************************************************/
/*
bool delContReverseOp1(cert searchCert)
{
	int opSelection = 0;
	int u = 0, v = 0;
	//enum operationType type = INVDELCONT1;
	bool valid  = true;

	//TODO Return an opList here for the user to select from, then get their selection and do it. The end.
	operationList list = getDC1RevOperationList(searchCert);
	printOperationList(list);
	
	//printf("\nBOOL: %d",listIsEmpty(list));
	
	if(!listIsEmpty(list))
	{
		printf("\nPlease select one of the operations above (0-%d): ",getListLength(list)-1);
		opSelection = getSearchOption();
		
		if(opSelection >=0 && opSelection < getListLength(list))
		{
			performOp(getListOp(list,opSelection));
		}
		else
		{
			printf("Invalid choice");
			valid = false;
		}
	}
	
	return valid;
}
*/
