#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include "graph.h"
#include "cert.h"


void interactiveEquivalenceSearch();
void certificateMenu();
void operationMenu(cert searchCert);
void printCertificateMenu();
void printOperationMenu();
int getSearchOption();
bool selectOpFromList(cert searchCert);
bool delContMenu(cert searchCert);
void notDone();
bool tryRemoveLine(searchCert);

void interactiveEquivalenceSearch()
{
	certificateMenu();
}

void certificateMenu()
{
	int menuOption;
	int valid = 1;


	//Get graph from file.
	//Create new cert
//	graph graph = initGraph(6);
//	addEdge(graph,0,1);
//	addEdge(graph,1,2);
//	addEdge(graph,2,3);
//	addEdge(graph,3,4);
//	addEdge(graph,4,5);

	graph graph=initGraph(12);
	addEdge(graph, 0, 1);
	addEdge(graph, 0, 2);
	addEdge(graph, 0, 8);
	addEdge(graph, 2, 1);
	addEdge(graph, 3, 1);
	addEdge(graph, 2, 4);
	addEdge(graph, 3, 4);
	addEdge(graph, 3, 5);
	addEdge(graph, 4, 6);
	addEdge(graph, 5, 6);
	addEdge(graph, 5, 7);
	addEdge(graph, 6, 7);
	addEdge(graph, 7, 9);
	addEdge(graph, 10, 9);
	addEdge(graph, 11, 9);
	addEdge(graph, 10, 8);
	addEdge(graph, 10, 11);
	addEdge(graph, 8, 11);
	
	//Kerri's graph
	/*graph graph = initGraph(12);
	addEdge(graph,0,1);
	addEdge(graph,0,2);
	addEdge(graph,0,8);
	addEdge(graph,1,2);
	addEdge(graph,1,3);
	addEdge(graph,2,4);
	addEdge(graph,3,4);
	addEdge(graph,3,5);
	addEdge(graph,4,6);
	addEdge(graph,5,6);
	addEdge(graph,5,7);
	addEdge(graph,6,7);
	addEdge(graph,7,11);
	addEdge(graph,8,9);
	addEdge(graph,8,10);
	addEdge(graph,9,10);
	addEdge(graph,9,11);
	addEdge(graph,10,11);*/
	
	cert searchCert = newCert(graph);

	while(1)
	{
		if(valid)
		{
			printCertificateData(searchCert);
			printCertificateMenu();
		}
		printf("\nPlease select from the menu above: ");
		menuOption = getSearchOption();
		printf("\n");
		switch(menuOption)
		{
		    case 1 : 	valid = printCertGraphs(searchCert); 
		    		break;
		    case 2 : 	valid = selectOpFromList(searchCert);
		    		break;
		    case 3 : 	valid = tryRemoveLine(searchCert);
		    		break;
		    case 4 : 	return;
		    default  : 	printf("Invalid option: Please select an option from the menu above"); 
		    		valid = 0;
		 }
     }
}
/*
void operationMenu(cert searchCert)
{
	int menuOption;
	bool valid = true;

	while(1)
	{
		if(valid)
		{
			printCertificateData(searchCert);
			printOperationMenu();
		}
		printf("\nPlease select from the menu above: ");
		menuOption = getSearchOption();
		printf("\n");
		switch(menuOption)
		{
		    case 1 : 	valid = selectOpFromList(searchCert, DELCONT);//delContOp(searchCert);
		    		break;
		    case 2 : 	valid = selectOpFromList(searchCert, ADDIDENT);//addIdentOp(searchCert);
		    		break;
		    case 3 : 	valid = selectOpFromList(searchCert, INVDELCONT1);//delContReverseOp1(searchCert);
		    		break;
		    case 4 : 	valid = selectOpFromList(searchCert, INVDELCONT2);//delContReverseOp2(searchCert);
		    		break;
		    case 5 : 	valid = selectOpFromList(searchCert, INVADDIDENT);//addIdentReverseOp(searchCert);
		    		break;
		    case 6 : 	valid = selectOpFromList(searchCert, CANCEL);
		    		break;
		    case 7 : 	valid = printCertGraphs(searchCert);
		    		break;
		    case 8 :	return;
		    default  : 	printf("Invalid option: Please select an option from the menu above"); 
		    		valid = false;
		 }
     }

}*/

void printCertificateMenu()
{
	printf("\nCertificate Options\n===================\n");
	printf("   1: Print the graphs in the last line of the certificate\n");
	printf("   2: Perform a certificate step operation\n");
	printf("   3: Remove the last line of the certificate\n");
	printf("   4: Back to previous menu\n");

}

/*void printOperationMenu()
{
	printf("\nAvailable Operations\n====================\n");
	printf("   1: Deletion-Contraction		(G -> G\\e - G/e)\n");
	printf("   2: Addition-Identification		(G -> G+e + G/e)\n");
	printf("   3: Deletion-Contraction Reversal 1 	(G\\e - G/e -> G)\n");
	printf("   4: Deletion-Contraction Reversal 2 	(G\\e - G -> G/e)\n");
	printf("   5: Addition-Identification Reversal	(G+e + G/e -> G)\n");
	printf("   6: Cancelation			(G - G -> 0)\n");
	printf("   7: Print the graphs in the last line of the certificate\n");
	printf("   8: Back to previous menu\n");
}*/

int getSearchOption()
{
	int option;
	char input[100];

	fgets(input, 100, stdin);
	while(input[0]=='\n')
	{
		fgets(input, 100, stdin);
	}
	if(sscanf(input, "%d", &option) !=1)
	{
		option = -1;
	}
	
	return option;
}


bool selectOpFromList(cert searchCert)
{
	int opSelection = 0;
	int u = 0, v = 0;
	//enum operationType type = INVDELCONT1;
	bool valid  = true;

	//TODO Return an opList here for the user to select from, then get their selection and do it. The end.
	operationList list = NULL;
	list = getAllOperations(searchCert);
	/*switch(optype)
	{
		case DELCONT     :	list = getDelContOperationList(searchCert);	break;
		case ADDIDENT    :	list = getAddIdentOperationList(searchCert);	break;
		case INVDELCONT1 :	list = getDC1RevOperationList(searchCert);	break;
		case INVDELCONT2 :	list = getDC2RevOperationList(searchCert);	break;
		case INVADDIDENT :	list = getAIRevOperationList(searchCert);	break;
		case CANCEL	 :	list = getCancelOperationList(searchCert);	break;
		default	         :	return NULL;
	}*/
	printOperationList(list);
	
	//If the list isn't empty
	if(!listIsEmpty(list))
	{
		//Get the user to select one of the operations from the list, and then do it.
		printf("\nPlease select one of the operations above (0-%d): ",getListLength(list)-1);
		opSelection = getSearchOption();
		
		if(opSelection >=0 && opSelection < getListLength(list))
		{
			performOp(getOpFromList(list,opSelection));
		}
		else
		{
			printf("Invalid choice");
			valid = false;
		}
	}
	
	return valid;
}

bool tryRemoveLine(cert searchCert)
{
	if(getLength(searchCert)==0)
	{
		printf("\nCannot remove the final line\n");
		return false;
	} 
	else
	{
		removeLastLine(searchCert);
		return true;
	}
}
